﻿//using ParaInt = TypyParametryczne.Para<int>;
using ParaInt = TypyParametryczne.Para<int,int>;

namespace TypyParametryczne
{
    /*
    class Para<T> : IComparable<Para<T>> where T : IComparable<T>
    {
        private T pierszy = default(T), drugi = default(T);

        public Para(T pierwszy, T drugi)
        {
            this.pierszy = pierwszy;
            this.drugi = drugi;
        }

        public override string ToString() 
        {
            return pierszy.ToString() + "\t" + drugi.ToString();
        }

        public int CompareTo(Para<T>? inna)
        {
            int wartość = this.pierszy.CompareTo(inna.pierszy);
            if (wartość != 0) return wartość;
            else return this.drugi.CompareTo(inna.drugi);
        }
    }
    */

    class Para<T1,T2> : IComparable<Para<T1,T2>>
        where T1 : IComparable<T1>
        where T2 : IComparable<T2>
    {
        private T1 pierszy = default(T1);
        private T2 drugi = default(T2);

        public Para(T1 pierwszy, T2 drugi)
        {
            this.pierszy = pierwszy;
            this.drugi = drugi;
        }

        public override string ToString()
        {
            return pierszy.ToString() + "\t" + drugi.ToString();
        }

        public int CompareTo(Para<T1,T2>? inna)
        {
            int wartość = this.pierszy.CompareTo(inna.pierszy);
            if (wartość != 0) return wartość;
            else return this.drugi.CompareTo(inna.drugi);
        }
    }

    internal class Program
    {
        private static void pokażTablicę<T>(T[] t)
        {
            Console.WriteLine($"Wyświetlam elementy tablicy {nameof(t)}");
            foreach (T et in t)
            {
                Console.WriteLine(et.ToString());
            }
        }


        static void Main(string[] args)
        {
            Random r = new Random();

            //======================

            //Para<int>[] ti = new Para<int>[10];
            ParaInt[] ti = new ParaInt[10];
            for (int i = 0; i < ti.Length; ++i)
            {
                ti[i] = new ParaInt(r.Next(10), r.Next(10));
            }

            pokażTablicę(ti);

            Array.Sort(ti);

            pokażTablicę(ti);

            //======================

            Para<string,string>[] ts = new Para<string,string>[10];
            for (int i = 0; i < ts.Length; ++i)
            {
                ts[i] = new Para<string,string>(r.Next(10).ToString(), r.Next(10).ToString());
            }

            pokażTablicę(ts);

            Array.Sort(ts);

            pokażTablicę(ts);

            //======================

            Para<int, string>[] tis = new Para<int, string>[10];
            for (int i = 0; i < tis.Length; ++i)
            {
                tis[i] = new Para<int, string>(r.Next(10), r.Next(10).ToString());
            }

            pokażTablicę(tis);

            Array.Sort(tis);

            pokażTablicę(tis);
        }
    }
}